<?php

namespace SGalinski\SgJobs\ViewHelpers\Backend\Widget;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use SGalinski\SgJobs\ViewHelpers\Backend\Widget\Controller\PaginateController;
use TYPO3\CMS\Fluid\Core\Widget\AbstractWidgetViewHelper;

/**
 * Class PaginateViewHelper
 *
 * @package SGalinski\SgJobs\ViewHelpers\Backend\Widget
 */
class PaginateViewHelper extends AbstractWidgetViewHelper {
	/**
	 * @var PaginateController
	 */
	protected $controller;

	/**
	 * Initializes the controller
	 *
	 * @param PaginateController $controller
	 */
	public function injectPaginateController(PaginateController $controller): void {
		$this->controller = $controller;
	}

	/**
	 * Register the ViewHelper arguments
	 */
	public function initializeArguments(): void {
		parent::initializeArguments();
		$this->registerArgument('objects', 'array', 'The objects to paginate', TRUE);
		$this->registerArgument('as', 'string', 'The name of the variable inside the pagination', TRUE);
		$this->registerArgument(
			'configuration',
			'array',
			'The configuration of the pagination',
			FALSE,
			[
				'itemsPerPage' => 10,
				'insertAbove' => FALSE,
				'insertBelow' => TRUE,
				'recordsLabel' => ''
			]
		);
	}

	/**
	 * Renders the paginator
	 *
	 * @return string
	 */
	public function render(): string {
		return $this->initiateSubRequest();
	}
}
